#include <EXTEND.API>
#include <ITEM.API>
#include <FM.API>

void pascal FT_Descend( void )
{
   auto ITEM iP       = _itemParam( 1 );
   auto USHORT uiType = _itemType( iP );

   auto ITEM iR;
   auto USHORT uiLen, n;
   auto char * pDescend;

   if ( ( uiType & NUMERIC ) && ( uiType & DOUBLE ) )
      iR = _itemPutND( 0, 0 - _itemGetND( iP ) );

   else if ( uiType & NUMERIC )
      iR = _itemPutNL( 0, 0 - _itemGetNL( iP ) );

   else if ( uiType & DATE )
      iR = _itemPutNL( 0, 0x4FD4C0L - _itemGetNL( iP ) );

   else if ( uiType & LOGICAL )
      iR = _itemPutL( 0, ( _itemGetL( iP ) > 0 ) ? 0 : 1 );

   else if ( uiType & CHARACTER )
   {
      uiLen = _itemSize( iP );

      pDescend = _xgrab( uiLen );

      _itemCopyC( iP, pDescend, uiLen );

      for ( n = 0; n < uiLen; n++ )
         pDescend[ n ] = -pDescend[ n ];

      iR = _itemPutCL( 0, pDescend, uiLen );

      _xfree( pDescend );
   }

   _itemReturn( iR );

   _itemRelease( iP );
   _itemRelease( iR );

   return;
}